#ifndef _XAP_H
#define _XAP_H

#define XAP_DATA_LEN 512
#define XAP_MSG_ELEMENTS 20
#define XAP_HEARTBEAT_INTERVAL 60

#define XAP_MSG_HBEAT  1		// special control message, type heartbeat
#define XAP_MSG_ORDINARY  2		// ordinary xap message type
#define XAP_MSG_UNKNOWN  0              // unknown xap message type
#define XAP_MSG_NONE 0                  // (or no message received)

extern char *XAP_FILTER_ANY;
extern char *XAP_FILTER_ABSENT;

struct parsedMsgElement {
	char *section;
	char *key;
	char *value;
};

typedef struct _xapFrame {
	int parsedMsgCount;
	struct parsedMsgElement parsedMsg[XAP_MSG_ELEMENTS];
} xAPFrame;

//frame.c
int xapGetType(xAPFrame *);
char *xapGetValue(xAPFrame *, char *section, char *key);
int xapIsValue(xAPFrame *,char *section, char *key, char *value);
int parseMsg(xAPFrame *frame, unsigned char *dataPacket, int len);

#endif
